var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    }
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) if (e.indexOf(p[i]) < 0)
            t[p[i]] = s[p[i]];
    return t;
};
import React, { Component } from 'react';
import { DragSource } from 'react-dnd';
import { ItemTypes } from './constants';
import { WidgetTab as WidgetTabComponent, Cancel } from '../components';
var widgetTabSource = {
    beginDrag: function (props) {
        return {
            widgetId: props.widgetId,
            isLastTab: props.isLastTab,
            isLonelyTab: props.isLonelyTab,
            containerId: props.containerId
        };
    }
};
var collect = function (connect, monitor) { return ({
    connectDragSource: connect.dragSource(),
    connectDragPreview: connect.dragPreview()
}); };
var WidgetTab = /** @class */ (function (_super) {
    __extends(WidgetTab, _super);
    function WidgetTab() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.handleClick = function () {
            _this.props.onClose();
        };
        return _this;
    }
    WidgetTab.prototype.render = function () {
        var _a = this.props, connectDragSource = _a.connectDragSource, connectDragPreview = _a.connectDragPreview, onClick = _a.onClick, onClose = _a.onClose, children = _a.children, props = __rest(_a, ["connectDragSource", "connectDragPreview", "onClick", "onClose", "children"]);
        /* tslint:disable:jsx-no-lambda */
        return (React.createElement(WidgetTabComponent, __assign({ onClick: onClick }, props, { innerRef: function (instance) { return connectDragSource(instance); } }),
            children,
            React.createElement(Cancel, { onClick: this.handleClick }, "\u2716\uFE0F")));
        /* tslint:enable:jsx-no-lambda */
    };
    return WidgetTab;
}(Component));
export default DragSource(ItemTypes.WIDGET_TAB, widgetTabSource, collect)(WidgetTab);
//# sourceMappingURL=WidgetTab.js.map