var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    }
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) if (e.indexOf(p[i]) < 0)
            t[p[i]] = s[p[i]];
    return t;
};
import React, { Component } from 'react';
import { WidgetTabDropzone as WidgetTabDropzoneComponent } from '../components';
import { ItemTypes } from './constants';
import { DropTarget } from 'react-dnd';
var containerTarget = {
    drop: function (props, monitor) {
        var item = monitor.getItem();
        props.onTabDrop(item);
    },
    canDrop: function (props, monitor) {
        var item = monitor.getItem();
        return props.widgetId !== item.widgetId;
    }
};
var collect = function (connect, monitor) { return ({
    connectDropTarget: connect.dropTarget(),
    isVisible: !!monitor.getItem(),
    isOver: monitor.isOver(),
    canDrop: monitor.canDrop()
}); };
var WidgetTabDropzone = /** @class */ (function (_super) {
    __extends(WidgetTabDropzone, _super);
    function WidgetTabDropzone() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    WidgetTabDropzone.prototype.render = function () {
        var _a = this.props, connectDropTarget = _a.connectDropTarget, props = __rest(_a, ["connectDropTarget"]);
        /* tslint:disable:jsx-no-lambda */
        return (React.createElement(WidgetTabDropzoneComponent, __assign({}, props, { innerRef: function (instance) { return connectDropTarget(instance); } })));
        /* tslint:enable:jsx-no-lambda */
    };
    return WidgetTabDropzone;
}(Component));
export default DropTarget([ItemTypes.WIDGET, ItemTypes.WIDGET_TAB], containerTarget, collect)(WidgetTabDropzone);
//# sourceMappingURL=WidgetTabDropzone.js.map