var __makeTemplateObject = (this && this.__makeTemplateObject) || function (cooked, raw) {
    if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
    return cooked;
};
import styled, { css } from 'styled-components';
export var Layout = styled('div')(templateObject_1 || (templateObject_1 = __makeTemplateObject(["\n  position: relative;\n  height: 100%;\n  width: 100%;\n"], ["\n  position: relative;\n  height: 100%;\n  width: 100%;\n"])));
export var WidgetTab = styled('div')(templateObject_2 || (templateObject_2 = __makeTemplateObject(["\n  border-bottom: 2px solid;\n  padding: 0.5rem 2rem;\n  white-space: nowrap;\n  position: relative;\n  font-size: 0.6rem;\n  z-index: 102;\n  cursor: pointer;\n  color: ", ";\n  border-color: ", ";\n  font-weight: ", ";\n"], ["\n  border-bottom: 2px solid;\n  padding: 0.5rem 2rem;\n  white-space: nowrap;\n  position: relative;\n  font-size: 0.6rem;\n  z-index: 102;\n  cursor: pointer;\n  color: ", ";\n  border-color: ", ";\n  font-weight: ", ";\n"])), function (props) { return (props.isActive ? '#000' : '#666'); }, function (props) { return (props.isActive ? '#9999de' : '#ccc'); }, function (props) { return (props.isActive ? 'bold' : 'normal'); });
export var Widget = styled('div')(templateObject_3 || (templateObject_3 = __makeTemplateObject(["\n  position: relative;\n  z-index: 0;\n  width: 100%;\n  height: 100%;\n"], ["\n  position: relative;\n  z-index: 0;\n  width: 100%;\n  height: 100%;\n"])));
export var WidgetTabs = styled('div')(templateObject_4 || (templateObject_4 = __makeTemplateObject(["\n  height: 1.8rem;\n  display: flex;\n\n  ", " {\n    margin-right: 0.5rem;\n  }\n"], ["\n  height: 1.8rem;\n  display: flex;\n\n  ", " {\n    margin-right: 0.5rem;\n  }\n"])), WidgetTab);
export var Cancel = styled('div')(templateObject_5 || (templateObject_5 = __makeTemplateObject(["\n  position: absolute;\n  height: 0.6rem;\n  width: 0.6rem;\n  background-size: cover;\n  cursor: pointer;\n  font-size: 0.8rem;\n  right: 0.2rem;\n  top: calc(50% - 0.6rem);\n"], ["\n  position: absolute;\n  height: 0.6rem;\n  width: 0.6rem;\n  background-size: cover;\n  cursor: pointer;\n  font-size: 0.8rem;\n  right: 0.2rem;\n  top: calc(50% - 0.6rem);\n"])));
export var WidgetTabDropzone = styled('div')(templateObject_6 || (templateObject_6 = __makeTemplateObject(["\n  position: absolute;\n  height: 1.8rem;\n  width: 100%;\n  display: ", ";\n  background: ", ";\n  top: 0;\n  left: 0;\n"], ["\n  position: absolute;\n  height: 1.8rem;\n  width: 100%;\n  display: ", ";\n  background: ",
    ";\n  top: 0;\n  left: 0;\n"])), function (props) { return (props.isVisible ? 'block' : 'none'); }, function (props) {
    return props.isOver && props.canDrop ? 'rgba(200, 200, 200, 0.3)' : 'transparent';
});
export var WidgetLastTabDropzone = styled('div')(templateObject_7 || (templateObject_7 = __makeTemplateObject(["\n  height: 1.8rem;\n  display: ", ";\n  background: ", ";\n  width: 100%;\n"], ["\n  height: 1.8rem;\n  display: ", ";\n  background: ",
    ";\n  width: 100%;\n"])), function (props) { return (props.isVisible ? 'block' : 'none'); }, function (props) {
    return props.isOver && props.canDrop ? 'rgba(200, 200, 200, 0.3)' : 'transparent';
});
export var Container = styled('div')(templateObject_8 || (templateObject_8 = __makeTemplateObject(["\n  transition: any 1s;\n  position: relative;\n  padding: 0;\n  overflow: hidden;\n  display: ", ";\n  width: ", "px;\n  height: ", "px;\n  flex-direction: ", ";\n  background: white;\n"], ["\n  transition: any 1s;\n  position: relative;\n  padding: 0;\n  overflow: hidden;\n  display: ", ";\n  width: ", "px;\n  height: ", "px;\n  flex-direction: ", ";\n  background: white;\n"])), function (props) { return (props.hasWidgets ? 'block' : 'flex'); }, function (props) { return props.containerWidth || '0'; }, function (props) { return props.containerHeight || '0'; }, function (props) { return (props.isVertical ? 'row' : 'column'); });
export var Separator = styled('div')(templateObject_11 || (templateObject_11 = __makeTemplateObject(["\n  background: rgba(255, 255, 255, 0.5);\n  z-index: 100;\n  ", ";\n"], ["\n  background: rgba(255, 255, 255, 0.5);\n  z-index: 100;\n  ",
    ";\n"])), function (props) {
    return props.isVertical
        ? css(templateObject_9 || (templateObject_9 = __makeTemplateObject(["\n          cursor: col-resize;\n          height: 100%;\n          width: 0.25rem;\n        "], ["\n          cursor: col-resize;\n          height: 100%;\n          width: 0.25rem;\n        "]))) : css(templateObject_10 || (templateObject_10 = __makeTemplateObject(["\n          cursor: row-resize;\n          height: 0.25rem;\n          width: 100%;\n        "], ["\n          cursor: row-resize;\n          height: 0.25rem;\n          width: 100%;\n        "])));
});
export var Dropzones = styled('div')(templateObject_12 || (templateObject_12 = __makeTemplateObject(["\n  position: absolute;\n  top: 1.8rem;\n  height: calc(100% - 1.8rem);\n  width: ", "px;\n"], ["\n  position: absolute;\n  top: 1.8rem;\n  height: calc(100% - 1.8rem);\n  width: ", "px;\n"])), function (props) { return props.dropzoneWidth; });
export var Dropzone = styled('div')(templateObject_18 || (templateObject_18 = __makeTemplateObject(["\n  display: ", ";\n  background: ", ";\n  position: absolute;\n  width: ", "px;\n  height: ", "px;\n  z-index: ", ";\n  ", ";\n"], ["\n  display: ", ";\n  background: ",
    ";\n  position: absolute;\n  width: ", "px;\n  height: ", "px;\n  z-index: ", ";\n  ",
    ";\n"])), function (props) { return (props.isVisible ? 'block' : 'none'); }, function (props) {
    return props.isOver && props.canDrop ? 'rgba(200, 200, 200, 0.3)' : 'transparent';
}, function (props) { return props.dropzoneWidth; }, function (props) { return props.dropzoneHeight; }, function (props) { return props.zIndex; }, function (props) {
    switch (props.position) {
        case 'left':
            return css(templateObject_13 || (templateObject_13 = __makeTemplateObject(["\n          left: 0;\n        "], ["\n          left: 0;\n        "])));
        case 'right':
            return css(templateObject_14 || (templateObject_14 = __makeTemplateObject(["\n          right: 0;\n        "], ["\n          right: 0;\n        "])));
        case 'bottom':
            return css(templateObject_15 || (templateObject_15 = __makeTemplateObject(["\n          bottom: 0;\n        "], ["\n          bottom: 0;\n        "])));
        case 'top':
            return css(templateObject_16 || (templateObject_16 = __makeTemplateObject(["\n          top: 0;\n        "], ["\n          top: 0;\n        "])));
        default:
            return css(templateObject_17 || (templateObject_17 = __makeTemplateObject(["\n          left: 0;\n          top: 0;\n          right: 0;\n          bottom: 0;\n        "], ["\n          left: 0;\n          top: 0;\n          right: 0;\n          bottom: 0;\n        "])));
    }
});
var templateObject_1, templateObject_2, templateObject_3, templateObject_4, templateObject_5, templateObject_6, templateObject_7, templateObject_8, templateObject_9, templateObject_10, templateObject_11, templateObject_12, templateObject_13, templateObject_14, templateObject_15, templateObject_16, templateObject_17, templateObject_18;
//# sourceMappingURL=index.js.map