import React from 'react';
import { DragSource } from 'react-dnd';
import { ItemTypes } from './dnd/constants';
var widgetSource = {
    beginDrag: function (props) {
        return {
            registeredWidgetId: props.registeredWidgetId
        };
    }
};
var collect = function (connect, monitor) { return ({
    connectDragSource: connect.dragSource()
}); };
var connectToReactTabWidget = function (WidgetLinkComponent) {
    return DragSource(ItemTypes.WIDGET, widgetSource, collect)(function (_a) {
        var connectDragSource = _a.connectDragSource, children = _a.children;
        return (React.createElement("div", { ref: function (instance) { return connectDragSource(instance); } },
            React.createElement(WidgetLinkComponent, null, children)));
    });
};
export default connectToReactTabWidget;
//# sourceMappingURL=connectToReactTabWidget.js.map